<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 																   *
 * 			Fichier 		:	install.php						   *
 * 			Cr le 		:	30 juillet 2002					   *
 * 			Dernire modif 	:	07 octobre 2002 				   *
 * 			Email			: 	wascripts@phpcodeur.net			   *
 * 			 Copyright 2002 PHPcodeur							   *
 * 							  									   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *																   *
 *  This program is free software; you can redistribute it and/or  *
 * 	modify it under the terms of the GNU General Public License as *
 * 	published by the Free Software Foundation; either version 2 of *
 *  the License, or (at your option) any later version.			   *
 * 																   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


$default_lang = 'francais'; 
$new_version = "2.0.2";
 
// Dsactivation de magic_quotes_runtime
set_magic_quotes_runtime(0); 

//
// magic_quotes_gpc et ajout ventuel des backslashes
//

if( !get_magic_quotes_gpc() )
{
	if( is_array($HTTP_POST_VARS) )
	{
		foreach( $HTTP_POST_VARS AS $key => $value )
		{
			if( is_array($HTTP_POST_VARS[$key]) )
			{
				foreach( $HTTP_POST_VARS[$key] AS $key2 => $value2 )
				{
					$HTTP_POST_VARS[$key][$key2] = addslashes($value2);
				}
				
				@reset($HTTP_POST_VARS[$key]);
			}
			else
			{
				$HTTP_POST_VARS[$key] = addslashes($value);
			}			
		}		
	}
}

require('includes/fonctions.inc.php');
require('includes/template.php');

$template = new Template('templates/');

$language = ( isset($HTTP_POST_VARS['language']) ) ? $HTTP_POST_VARS['language'] : $default_lang;  
require('language/' . $language . '/lang_admin.php');

$prestart 	= ( isset($HTTP_POST_VARS['prestart']) ) ? true : false;
$start 		= ( isset($HTTP_POST_VARS['start']) ) ? true : false;
$install 	= ( $HTTP_POST_VARS['type'] == 'install' ) ? true : false;
$upgrade 	= ( $HTTP_POST_VARS['type'] == 'upgrade' ) ? true : false;
$update 	= ( $HTTP_POST_VARS['type'] == 'update' ) ? true : false;
$error 		= false;

$template->set_filenames( array(
	'body' => 'install.tpl' 
));	

$template->assign_vars( array(
	'GENERAL_TITLE' => $lang['general_title_install'], 
	'NEW_VERSION' => $new_version 
));	

if( $prestart && !$start && $language != $HTTP_POST_VARS['prev_language'] )
{
	$prestart = false;
}

if( !$prestart )
{
	$res = @opendir("./language/");
	
	if( !$res )
	{
		echo 'Le dossier des langues est introuvable ! / Unable to detect folder language !';
		exit;
	}
	
	$option = array();
	$values = array();
	$default = array();
	while( $folder = readdir($res) ) 
	{ 
		if( $folder != "." && $folder != ".." && !strpos( $folder, ".") ) 
		{
			$option[] = $folder;
			$values[] = $folder;			
			if( $folder == $language )
			{
				$default[] = $folder;
			}
		} 
	}  

	closedir($res); 

	$box_lang = build_select("language", $option, $values, $default);
	
	$option2 = array($lang['install'], $lang['upgrade'], $lang['update']);
	$values2 = array('install', 'upgrade', 'update');
	$default2 = array(); 

	$box_type = build_select("type", $option2, $values2, $default2);
	
	$template->assign_block_vars('welcome', array(
		'L_WELCOME' => nl2br( sprintf($lang['welcome'], '<a href="readme_' . $language . '.html" target="_blank">', '</a>') ), 
		'L_SELECT_LANGUAGE' => $lang['select_langue'], 
		'L_SELECT_TYPE' => $lang['select_type'], 
		'BOX_LANGUAGE' => $box_lang, 
		'BOX_TYPE' => $box_type, 
		'L_BUTTON1' => $lang['button1'], 
		'S_HIDDEN_FIELD' => '<input type="hidden" name="prev_language" value="' . $language .'" />' 
	));
}
else
{
	if( $start )
	{
		$dbtype 	= $HTTP_POST_VARS['dbtype'];
		$dbhost 	= $HTTP_POST_VARS['dbhost'];
		$dbname 	= $HTTP_POST_VARS['dbname'];
		$dbuser 	= $HTTP_POST_VARS['dbuser'];
		$dbpassword = $HTTP_POST_VARS['dbpwd'];
		$prefixe 	= $HTTP_POST_VARS['prefixe'];
	
		$admin_email 		= $HTTP_POST_VARS['admin_email'];
		$admin_user 		= $HTTP_POST_VARS['admin_user'];
		$admin_pwd 			= $HTTP_POST_VARS['admin_pwd'];
		$admin_pwd_confirm 	= $HTTP_POST_VARS['admin_pwd_confirm'];
		$pass_encrypt 		= md5($admin_pwd);
		
		$sitename 	= $HTTP_POST_VARS['sitename'];
		$urlsite 	= $HTTP_POST_VARS['urlsite'];
		$urlscript 	= $HTTP_POST_VARS['urlscript'];
		$emailadmin = $HTTP_POST_VARS['emailadmin']; 
		
		$date = time(); 
		
		if( ( $install || $upgrade ) && 
			( $dbhost == '' || $dbname == '' || $dbuser == '' || $prefixe == '' || $admin_email == '' || 
			  $admin_user == '' || $admin_pwd == '' || $admin_pwd_confirm == '' || $sitename == '' || 
			  $urlsite == '' || $urlscript == '' || $emailadmin == '' ) )
		{
			$msg_error = $lang['fields_empty'];
			$error = true;
		}
		else if( $update )
		{
			require('includes/config.inc.php');		
		}
	
		require('sql/db_type.php'); 
		
		if( !$error && ( $admin_pwd != $admin_pwd_confirm ) )
		{
			$msg_error = $lang['error_pass_admin'];
			$error = true;
		}
		
		//
		// On allonge le temps maximum d'execution du script. 
		//			
		@set_time_limit(1200);
		
		if( $install && !$error )
		{
			switch($dbtype)
			{
				case "mysql":
					$delimiter = ";";
					$delimiter2 = ";";
					break;
				
				case "mssql":
					$delimiter = "GO";
					$delimiter2 = ";";
					break;
			}
			
			$fp = @fopen("sql/" . $dbtype . "/" . $dbtype . "_tables.sql", "r");
			$content = fread($fp, filesize("sql/" . $dbtype . "/" . $dbtype . "_tables.sql"));
			fclose($fp);			
			$sql_install = _sql_array($content, $delimiter, $prefixe); 
			
			$total_sql = count($sql_install)-1;
			
			for( $i = 0; $i < $total_sql; $i++ )
			{
				$result = $db->query($sql_install[$i]); 
				
				if( !$result )
				{
					$sql_error = $db->sql_error();
					
					$template->assign_block_vars('result', array(
						'TITLE' => $lang['title_result'], 
						'MSG_RESULT' => nl2br(sprintf($lang['error_install'], $sql_error['error'])) 
					));
						
					$template->pparse('body');
					exit;
				}
			}
			
			$sql_install = array();
			$total_sql = 0;
			
			$fp = @fopen("sql/" . $dbtype . "/" . $dbtype . "_data.sql", "r");
			$content = fread($fp, filesize("sql/" . $dbtype . "/" . $dbtype . "_data.sql"));
			fclose($fp);			
			$sql_install = _sql_array($content, $delimiter, $prefixe); 
			
			$total_sql = count($sql_install)-1;
			
			for( $i = 0; $i < $total_sql; $i++ )
			{
				$result = $db->query($sql_install[$i]); 
				
				if( !$result )
				{
					$sql_error = $db->sql_error();
					
					$template->assign_block_vars('result', array(
						'TITLE' => $lang['title_result'], 
						'MSG_RESULT' => nl2br(sprintf($lang['error_install'], $sql_error['error'])) 
					));
						
					$template->pparse('body');
					exit;
				}
			}
			
			$total_sql = 0;
			$sql[] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('language', '$language')";
			$sql[] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('sitename','$sitename')";
			$sql[] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('urlsite','$urlsite')";
			$sql[] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('path','$urlscript')";
			$sql[] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('emailadmin','$emailadmin')";
			$sql[] = "UPDATE " . $prefixe . "admin SET user = '$admin_user', passwd = '$pass_encrypt', email = '$admin_email' WHERE user = 'admin'";
			
			$total_sql = count($sql);
			
			for( $i = 0; $i < $total_sql; $i++ )
			{
				$result = $db->query($sql[$i]); 
				
				if( !$result )
				{
					$sql_error = $db->sql_error();
					
					$template->assign_block_vars('result', array(
						'TITLE' => $lang['title_result'], 
						'MSG_RESULT' => nl2br(sprintf($lang['error_install'], $sql_error['error'])) 
					));
						
					$template->pparse('body');
					exit;
				}
			}			
		}
		else if( $upgrade && !$error )
		{
			$sql_upgrade['create'][] = "CREATE TABLE " . $prefixe . "admin ( admin_id TINYINT(3) NOT NULL auto_increment, user VARCHAR(50) NOT NULL default '', passwd VARCHAR(32) NOT NULL default '', email VARCHAR(255) NOT NULL default '', droits TINYINT(1) NOT NULL default '1', PRIMARY KEY  (admin_id)) TYPE=MyISAM;";
			$sql_upgrade['create'][] = "CREATE TABLE " . $prefixe . "liste ( liste_id TINYINT(3) NOT NULL auto_increment, nom VARCHAR(100) NOT NULL default '', choix_format TINYINT(1) NOT NULL default '1', email_confirm TINYINT(1) NOT NULL default '0', limitevalidate TINYINT(3) NOT NULL default '0', form_url VARCHAR(255) NOT NULL, PRIMARY KEY  (liste_id)) TYPE=MyISAM;";
			$sql_upgrade['create'][] = "CREATE TABLE " . $prefixe . "session ( session_id CHAR(32) NOT NULL default '', admin_id TINYINT(3) NOT NULL default '0', session_start INT(11) NOT NULL default '0', session_time INT(11) NOT NULL default '0', PRIMARY KEY  (session_id)) TYPE=HEAP;";
			$sql_upgrade['rename'][] = "ALTER TABLE `" . $prefixe . "newsletter` RENAME `" . $prefixe . "abonnes`";
			$sql_upgrade['rename'][] = "ALTER TABLE `" . $prefixe . "newsletter_log` RENAME `" . $prefixe . "log`";
			$sql_upgrade['rename'][] = "ALTER TABLE `" . $prefixe . "newsletter_config` RENAME `" . $prefixe . "config`";
			$sql_upgrade['config'][] = "DELETE FROM " . $prefixe . "config WHERE nom IN ('user_admin','pass_admin','nom','formulaire','choix_format','limitevalidate')";
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "admin (user, passwd, email, droits) VALUES('$admin_user','$pass_encrypt','$admin_email',3)";
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('session_duree',3600)";
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('use_smtp',0)";
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('smtp_host','')";
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('smtp_port',25)";
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('smtp_user','')";
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('smtp_pass','')";
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('popup_version',0)";		
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('email_new_inscrit',0)";
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('signature','Signature de la newsletter')";
			$sql_upgrade['config'][] = "INSERT INTO " . $prefixe . "config (nom, valeur) VALUES('hebergeur',1)";
			$sql_upgrade['config'][] = "UPDATE " . $prefixe . "config SET valeur = '$new_version' WHERE nom = 'version'";
			$sql_upgrade['config'][] = "UPDATE " . $prefixe . "config SET valeur = '$emailadmin' WHERE nom = 'emailadmin'";
			$sql_upgrade['config'][] = "UPDATE " . $prefixe . "config SET valeur = '$urlsite' WHERE nom = 'urlsite'";
			$sql_upgrade['config'][] = "UPDATE " . $prefixe . "config SET valeur = '$urlscript' WHERE nom = 'path'";
			$sql_upgrade['config'][] = "UPDATE " . $prefixe . "config SET valeur = '$sitename' WHERE nom = 'sitename'";
			$sql_upgrade['log'][] = "ALTER TABLE `" . $prefixe . "log` CHANGE `id` `log_id` SMALLINT(5) UNSIGNED NOT NULL AUTO_INCREMENT, CHANGE `sujet` `sujet` VARCHAR(100) NOT NULL, CHANGE `type_html` `body_html` MEDIUMTEXT NOT NULL, CHANGE `type_texte` `body_text` MEDIUMTEXT NOT NULL, CHANGE `date` `date` INT(11) NOT NULL";
			$sql_upgrade['log'][] = "ALTER TABLE `" . $prefixe . "log` ADD `liste_id` TINYINT(3) DEFAULT '0' NOT NULL AFTER `log_id`, ADD `attach` TEXT NOT NULL, ADD `send` TINYINT(1) DEFAULT '0' NOT NULL";
			$sql_upgrade['abonnes'][] = "ALTER TABLE `" . $prefixe . "abonnes` ADD `code` VARCHAR(16) NOT NULL AFTER `email`";
			$sql_upgrade['abonnes'][] = "ALTER TABLE `" . $prefixe . "abonnes` ADD `date` INT(11) DEFAULT '0' NOT NULL AFTER `code`";
			$sql_upgrade['abonnes'][] = "ALTER TABLE `" . $prefixe . "abonnes` ADD `liste_id` TINYINT(1) DEFAULT '0' NOT NULL AFTER `format`";
			$sql_upgrade['abonnes'][] = "ALTER TABLE `" . $prefixe . "abonnes` ADD `actif` TINYINT(1) DEFAULT '0' NOT NULL AFTER `liste_id`, CHANGE `id` `id` MEDIUMINT(8) UNSIGNED NOT NULL AUTO_INCREMENT, CHANGE `email` `email` VARCHAR(255) NOT NULL, DROP `recu`";
			$sql_upgrade['abonnes'][] = "UPDATE `" . $prefixe . "abonnes` SET date = '$date'";
			
			$sql = "SELECT * 
					FROM " . $prefixe . "newsletter_config 
					WHERE nom = 'user_admin' 
					   OR nom = 'pass_admin' 
					   OR nom = 'choix_format' 
					   OR nom = 'version'";
			if( !($result = $db->query($sql)) )
			{
				$template->assign_block_vars('result', array(
					'TITLE' => $lang['title_result_upgrade'], 
					'MSG_RESULT' => $lang['no_config'] 
				));
							
				$template->pparse('body');
				exit;
			}
		
			while( $row = $db->fetch_array($result) )
			{
				$acces[$row['nom']] = $row['valeur'];
			}
			
			$db->free_result($result); 
			
			if( $acces['user_admin'] != $admin_user || $acces['pass_admin'] != $pass_encrypt )
			{
				$msg_error = $lang['erreur_connexion_admin'];
				$error = true;
			}
			
			if( !$error )
			{
				$sql_error = false;
				$sql_file = "upgrade_log.txt";
				$log_file = '';
			
				//
				// Cration des nouvelles tables
				//
				$msg_result = ' <u>' . $lang['step_create'] . '</u><br />';
				$msg_result .= '<ul type="disc">';
			
				foreach( $sql_upgrade['create'] AS $sql )
				{
					if( !($result = $db->query($sql)) )
					{
						$resultat = '<font color="red">' . $lang['echec'] . '</font>';
						$sql_error = true;
						$log_file .= "----------------------\n";
						$log_file .= "Query : " . $sql . "\n\n";
						$error_log = $db->sql_error();
						$log_file .= "Errno : " . $error_log['errno'] . " / Error : " . $error_log['error'] . " \n\n";
					}
					else
					{
						$resultat = '<font color="green">OK</font>';
					}
				
					$msg_result .= '<li> ' . $sql . ' &gt;&gt; <b>' . $resultat . '</b></li>';
				}
			
				$msg_result .= '</ul><br />';
			
				//
				// On renomme les tables existantes
				//
				$msg_result .= ' <u>' . $lang['step_rename'] . '</u><br />';
				$msg_result .= '<ul type="disc">';
			
				foreach( $sql_upgrade['rename'] AS $sql )
				{
					if( !($result = $db->query($sql)) )
					{
						$resultat = '<font color="red">' . $lang['echec'] . '</font>';
						$sql_error = true;
						$log_file .= "----------------------\n";
						$log_file .= "Query : " . $sql . "\n\n";
						$error_log = $db->sql_error();
						$log_file .= "Errno : " . $error_log['errno'] . " / Error : " . $error_log['error'] . " \n\n";
					}
					else
					{
						$resultat = '<font color="green">OK</font>';
					}
				
					$msg_result .= '<li> ' . $sql . ' &gt;&gt; <b>' . $resultat . '</b></li>';
				}
			
				$msg_result .= '</ul><br />';
			
				//
				// On met  jour la table de configuration
				//
				$msg_result .= ' <u>' . $lang['step_config'] . '</u><br />';
				$msg_result .= '<ul type="disc">';
			
				foreach( $sql_upgrade['config'] AS $sql )
				{
					if( !($result = $db->query($sql)) )
					{
						$resultat = '<font color="red">' . $lang['echec'] . '</font>';
						$sql_error = true;
						$log_file .= "----------------------\n";
						$log_file .= "Query : " . $sql . "\n\n";
						$error_log = $db->sql_error();
						$log_file .= "Errno : " . $error_log['errno'] . " / Error : " . $error_log['error'] . " \n\n";
					}
					else
					{
						$resultat = '<font color="green">OK</font>';
					}
				
					$msg_result .= '<li> ' . $sql . ' &gt;&gt; <b>' . $resultat . '</b></li>';
				}
			
				$msg_result .= '</ul><br />';
			
				//
				// Insertion de la liste de diffusion dans la table liste
				//
				$msg_result .= ' <u>' . $lang['step_liste'] . '</u><br />';
				$msg_result .= '<ul type="disc">';
			
				$sql_upgrade['liste'] = "INSERT INTO " . $prefixe . "liste (nom, choix_format, email_confirm, limitevalidate, form_url) VALUES('Default list','" . $acces['choix_format'] . "','1','3','http://www.domaine.com/formpage.php')";
				if( !($result = $db->query($sql_upgrade['liste'])) )
				{
					$resultat = '<font color="red">' . $lang['echec'] . '</font>';
					$sql_error = true;
					$log_file .= "----------------------\n";
					$log_file .= "Query : " . $sql_upgrade['liste'] . "\n\n";
					$error_log = $db->sql_error();
					$log_file .= "Errno : " . $error_log['errno'] . " / Error : " . $error_log['error'] . " \n\n";
				}
				else
				{
					$resultat = '<font color="green">OK</font>';
				}
				
				$msg_result .= '<li> ' . $sql_upgrade['liste'] . ' &gt;&gt; <b>' . $resultat . '</b></li>';
						
				$msg_result .= '</ul><br />';
			
				//
				// On s'occupe de la table log et on convertit les dates de type 0000-00-00 en timestamp unix
				//
				$msg_result .= ' <u>' . $lang['step_log'] . '</u><br />';
				$msg_result .= '<ul type="disc">';
			
				$sql = "SELECT id, date FROM " . $prefixe . "log";
				if( !($result = $db->query($sql)) )
				{
					$resultat = '<font color="red">' . $lang['echec'] . '</font>';
					$msg_result .= '<li> ' . $sql . ' &gt;&gt; <b>' . $resultat . '</b></li>';
				}
				else
				{
					while( $row = $db->fetch_array($result) )
					{
						$elt = explode("-", $row['date']);
						$convert_date = mktime( 0, 0, 0, $elt[1], $elt[2], $elt[0]);
					
						$sql_upgrade['log'][] = "UPDATE `" . $prefixe . "log` 
											 	SET liste_id = '1', 
													 date = '$convert_date', 
													 send = '1' 
											 	WHERE log_id = '" . $row['id'] . "'";
					}
				
					$db->free_result($result);
				
					foreach( $sql_upgrade['log'] AS $sql )
					{
						if( !($result = $db->query($sql)) )
						{
							$resultat = '<font color="red">' . $lang['echec'] . '</font>';
							$sql_error = true;
							$log_file .= "----------------------\n";
							$log_file .= "Query : " . $sql . "\n\n";
							$error_log = $db->sql_error();
							$log_file .= "Errno : " . $error_log['errno'] . " / Error : " . $error_log['error'] . " \n\n";
						}
						else
						{
							$resultat = '<font color="green">OK</font>';
						}

						$msg_result .= '<li> ' . $sql . ' &gt;&gt; <b>' . $resultat . '</b></li>';
					}
				}
			
				$msg_result .= '</ul><br />';
			
				//
				// On s'occupe de la table des abonns
				// On ajoute les entres dans la table abo_liste et on convertit la table abonns
				//
				$msg_result .= ' <u>' . $lang['step_abo'] . '</u><br />';
				$msg_result .= '<ul type="disc">';
			
				$sql = "SELECT * FROM " . $prefixe . "abonnes";
				if( !($result = $db->query($sql)) )
				{
					$resultat = '<font color="red">' . $lang['echec'] . '</font>';
					$msg_result .= '<li> ' . $sql . ' &gt;&gt; <b>' . $resultat . '</b></li>';
				}
				else
				{
					while( $row = $db->fetch_array($result) )
					{
						$format = ( $row['format'] == 'html' ) ? 2 : 1 ;
						$code = get_code();
					
						$sql_upgrade['abonnes'][] = "UPDATE " . $prefixe . "abonnes SET code = '$code', actif = '1', format = '$format', liste_id = '1' WHERE id = '" . $row['id'] . "'";
					}
				
					$db->free_result($result);
				
					$sql_upgrade['abonnes'][] = "ALTER TABLE " . $prefixe . "abonnes CHANGE `format` `format` TINYINT(1) NOT NULL default '1'";
				
					foreach( $sql_upgrade['abonnes'] AS $sql )
					{
						if( !($result = $db->query($sql)) )
						{
							$resultat = '<font color="red">' . $lang['echec'] . '</font>';
							$sql_error = true;
							$log_file .= "----------------------\n";
							$log_file .= "Query : " . $sql . "\n\n";
							$error_log = $db->sql_error();
							$log_file .= "Errno : " . $error_log['errno'] . " / Error : " . $error_log['error'] . " \n\n";
						}
						else
						{
							$resultat = '<font color="green">OK</font>';
						}

						$msg_result .= '<li> ' . $sql . ' &gt;&gt; <b>' . $resultat . '</b></li>';
					}
				}
			
				$msg_result .= '</ul><br />';
			
				//
				// On s'occupe de la table des inscriptions temporaires
				// Transfert des donnes sur la table abonns, conversion des donnes
				// Ajout d'entres dans la table abo_liste et suppression de la table temporaire
				//
				$msg_result .= ' <u>' . $lang['step_temp'] . '</u><br />';
				$msg_result .= '<ul type="disc">';
			
				$sql = "SELECT MAX(id) AS maxid FROM " . $prefixe . "abonnes";
				$result = $db->query($sql);
				$max_id = $db->result($result, 0, "maxid");
				$db->free_result($result);
			
				$sql = "SELECT * FROM " . $prefixe . "newsletter_temp";
				if( !($result = $db->query($sql)) )
				{
					$resultat = '<font color="red">' . $lang['echec'] . '</font>';
					$msg_result .= '<li> ' . $sql . ' &gt;&gt; <b>' . $resultat . '</b></li>';
				}
				else
				{
					$num = $db->num_rows($result);
					$start = $max_id + 1;
					$end = $max_id + 1 + $num;
					for( $i = $start; $i < $end; $i++ )
					{
						$row = $db->fetch_array($result);
						$format = ( $row['format'] == 'html' ) ? 2 : 1 ;
						$code = get_code();
						$elt = explode("-", $row['date']);
						$convert_date = mktime( 0, 0, 0, $elt[1], $elt[2], $elt[0]);
					
						$sql_upgrade['temp'][] = "INSERT INTO " . $prefixe . "abonnes (id, email, code, date, format, liste_id, actif) VALUES('$i','" . $row['email'] . "','$code','$convert_date','$format','1','0')";
					}
				
					$db->free_result($result);
				
					$sql_upgrade['temp'][] = "DROP TABLE `" . $prefixe . "newsletter_temp`";
				
					foreach( $sql_upgrade['temp'] AS $sql )
					{
						if( !($result = $db->query($sql)) )
						{
							$resultat = '<font color="red">' . $lang['echec'] . '</font>';
							$sql_error = true;
							$log_file .= "----------------------\n";
							$log_file .= "Query : " . $sql . "\n\n";
							$error_log = $db->sql_error();
							$log_file .= "Errno : " . $error_log['errno'] . " / Error : " . $error_log['error'] . " \n\n";
						}
						else
						{
							$resultat = '<font color="green">OK</font>';
						}

						$msg_result .= '<li> ' . $sql . ' &gt;&gt; <b>' . $resultat . '</b></li>';
					}
				}
			
				$msg_result .= '</ul><br />';
			
				$msg_result .= '<br />';
			
				//
				// On optimise les tables
				//
				$db->query("OPTIMIZE TABLE `" . $prefixe . "abonnes`, `" . $prefixe . "log`, `" . $prefixe . "config`");
			}			
		}
		else if( $update && !$error )
		{
			include('includes/constantes.php');
		
			$sql = "SELECT * FROM " . CONFIG;
			if( !($result = $db->query($sql)) )
			{
				$template->assign_block_vars('result', array(
					'TITLE' => $lang['title_result_upgrade'], 
					'MSG_RESULT' => $lang['no_config'] 
				));
							
				$template->pparse('body');
				exit;
			}
		
			while( $row = $db->fetch_array($result) )
			{
				$newsletter_config[$row['nom']] = $row['valeur'];
			}	
				
			$db->free_result($result);
		
			$sql = "SELECT COUNT(*) AS adm 
					FROM " . ADMIN . " 
					WHERE LOWER(user) = '" . strtolower($admin_user) . "' 
					  AND passwd = '$pass_encrypt'";
			if( !($result = $db->query($sql)) )
			{
				$template->assign_block_vars('result', array(
					'TITLE' => $lang['title_result_upgrade'], 
					'MSG_RESULT' => $lang['no_config'] 
				));
							
				$template->pparse('body');
				exit;
			}
		
			$adm = $db->result($result, 0, "adm");
		
			if( !$adm )
			{
				$msg_error = $lang['erreur_connexion_admin'];
				$error = true;
			}
		
			if( !$error )
			{
				$sql_error = false;
				$sql_file = "update_log.txt";
				$log_file = '';
		
				$old_version = $newsletter_config['version']; 			
		
				switch($old_version)
				{
					case '2.0Beta':
						// pas de changement dans la base de donnes
				
					case '2.0.0':
						// pas de changement dans la base de donnes
					
						$config_file = "<?php \n\n";
						$config_file .= "//\n";
						$config_file .= "// Paramtres d'accs  la base de donnes \n";
						$config_file .= "// Ne pas modifier ! \n";
						$config_file .= "//\n\n";
						$config_file .= "\$dbtype = \"$dbtype\"; \n\n";
						$config_file .= "\$dbhost = \"$dbhost\"; \n";
						$config_file .= "\$dbuser = \"$dbuser\"; \n";
						$config_file .= "\$dbpassword = \"$dbpassword\"; \n";
						$config_file .= "\$dbname = \"$dbname\"; \n\n";
						$config_file .= "\$prefixe = \"$prefixe\"; \n\n";
						$config_file .= "?>";
						
						@chmod("includes", 0777);
						//
						// Cration du fichier config.inc.php 
						//
						$fp = @fopen("includes/config.inc.php", "w");
	
						if( !$fp )
						{
							$template->assign_block_vars('result', array(
								'TITLE' => $lang['title_result'], 
								'MSG_RESULT' => $lang['error_create_file_config'] 
							));
						
							$template->pparse('body');
							exit;
						}

						fwrite($fp, $config_file);
						fclose($fp);
						
						@chmod("includes", 0755);
				
					case '2.0.1':
						$sql_update[] = "ALTER TABLE " . SESSIONS . " CHANGE `session_id` `session_id` CHAR(32) NOT NULL";
						$sql_update[] = "ALTER TABLE " . SESSIONS . " TYPE=HEAP";
						break;
			
					default:
						$template->assign_block_vars('result', array(
							'TITLE' => $lang['title_result_upgrade'], 
							'MSG_RESULT' => $lang['update_not_required'] 
						));
							
						$template->pparse('body');
						exit;
						break;
				}
			
				$sql_update[] = "UPDATE " . CONFIG . " SET valeur = '$new_version' WHERE nom = 'version'";
						
				for( $i = 0; $i < count($sql_update); $i++ )
				{
					if( !$sql_error )
					{
						if( !($result = $db->query($sql_update[$i])) )
						{
							$sql_error = true;
							$log_file .= "----------------------\n";
							$log_file .= "Query : " . $sql_update[$i] . "\n\n";
							$error_log = $db->sql_error();
							$log_file .= "Errno : " . $error_log['errno'] . " / Error : " . $error_log['error'] . " \n\n";
						}
					}
				}
			}
		}
		
		$db->close_connexion();	
		
		if( !$error )
		{
			if( $install || $upgrade )
			{
				$config_file  = "<?php \n\n";
				$config_file .= "//\n";
				$config_file .= "// Paramtres d'accs  la base de donnes \n";
				$config_file .= "// Ne pas modifier ! \n";
				$config_file .= "//\n\n";
				$config_file .= "\$dbtype = \"$dbtype\"; \n\n";
				$config_file .= "\$dbhost = \"$dbhost\"; \n";
				$config_file .= "\$dbuser = \"$dbuser\"; \n";
				$config_file .= "\$dbpassword = \"$dbpassword\"; \n";
				$config_file .= "\$dbname = \"$dbname\"; \n\n";
				$config_file .= "\$prefixe = \"$prefixe\"; \n\n";
				$config_file .= "?>";
				
				@chmod("includes", 0777);
				//
				// Cration du fichier config.inc.php 
				//
				$fp = @fopen("includes/config.inc.php", "w");
	
				if( !$fp && !$error )
				{
					$template->assign_block_vars('result', array(
						'TITLE' => $lang['title_result'], 
						'MSG_RESULT' => $lang['error_create_file_config'] 
					));
						
					$template->pparse('body');
					exit;
				}

				fwrite($fp, $config_file);
				fclose($fp);
				
				@chmod("includes", 0755);
			}
		
			$fp = false;
		
			if( $upgrade || $update )
			{
				if( $sql_error )
				{
					$fp = @fopen($sql_file, "w");
					if( $fp )
					{
						fwrite($fp, $log_file);
						fclose($fp);
					}
				}
			}
		
			if( $install )
			{
				$title = $lang['title_result_install'];
				$succes_text = $lang['success_install'];
				$failed_text_without_log = $lang['error_install_without_log'];
			}
			else if( $upgrade || $update )
			{
				$title = $lang['title_result_upgrade'];
				$succes_text = $lang['success_upgrade'];
				$failed_text_with_log = $lang['error_upgrade_with_log'];
				$failed_text_without_log = $lang['error_upgrade_without_log'];
			}
		
			$msg_result .= ( !$sql_error ) ? nl2br( sprintf($succes_text, '<a href="admin/login.php">', '</a>') ) : ( ( $fp ) ? nl2br( sprintf($failed_text_with_log, '<a href="upgrade_log.txt" target="_blank">', '</a>') ) : nl2br($failed_text_without_log) );
		
			$template->assign_block_vars('result', array(
				'TITLE' => $title, 
				'MSG_RESULT' => $msg_result 
			));
						
			$template->pparse('body');
			exit;
		}
	}
	
	$domaine = ( !empty($HTTP_SERVER_VARS['SERVER_NAME']) ) ? $HTTP_SERVER_VARS['SERVER_NAME'] : '';
	$path = substr($HTTP_SERVER_VARS['PHP_SELF'], 0, strlen($HTTP_SERVER_VARS['PHP_SELF']) - 11);
	
	if( $upgrade )
	{
		if( @file_exists("includes/config.inc.php") )
		{
			include('includes/config.inc.php');
		}
	}
	
	$s_hidden_field = '<input type="hidden" name="language" value="' . $language .'" />';
	$s_hidden_field .= '<input type="hidden" name="type" value="' . $HTTP_POST_VARS['type'] . '" />';
	$s_hidden_field .= '<input type="hidden" name="prestart" value="1" />';
	
	$template->assign_block_vars('form', array(
		'TITLE_INSTALL2' => $lang['title_install2'], 
		'L_ADMIN_EMAIL' => $lang['admin_email'], 
		'L_ADMIN_USER' => $lang['admin_user'], 
		'L_ADMIN_PWD' => $lang['admin_pwd'], 
		'L_ADMIN_PWD_CONFIRM' => $lang['admin_pwd_confirm'], 
		'L_BUTTON_INSTALL' => $lang['button_install'], 
		
		'ADMIN_EMAIL' => $HTTP_POST_VARS['admin_email'], 
		'ADMIN_USER' => stripslashes($HTTP_POST_VARS['admin_user']), 
		'S_HIDDEN_FIELD' => $s_hidden_field  
	));
	
	if( $install || $upgrade )
	{
		$template->assign_block_vars('form.install_or_upgrade', array(
			'TITLE_INSTALL1' => $lang['title_install1'], 
			'TITLE_INSTALL3' => $lang['title_install3'], 
			'L_DBTYPE' => $lang['dbtype'], 
			'L_DBHOST' => $lang['dbhost'], 
			'L_DBNAME' => $lang['dbname'], 
			'L_DBUSER' => $lang['dbuser'], 
			'L_DBPWD' => $lang['dbpwd'], 
			'L_PREFIXE' => $lang['prefixe'], 
			'L_SITENAME' => $lang['name_site'], 
			'L_URLSITE' => $lang['url_site'], 
			'L_URLSCRIPT' => $lang['url_script'], 
			'L_EMAILADMIN' => $lang['email_admin'], 
			
			'DBHOST' => $dbhost, 
			'DBNAME' => $dbname, 
			'DBUSER' => $dbuser, 
			'PREFIXE' => ( !empty($prefixe) ) ? $prefixe : 'wa_', 
			'SITENAME' => stripslashes($sitename), 
			'URLSITE' => ( !empty($HTTP_POST_VARS['urlsite']) ) ? $HTTP_POST_VARS['urlsite'] : 'http://' . $domaine, 
			'URLSCRIPT' => ( !empty($HTTP_POST_VARS['urlscript']) ) ? $HTTP_POST_VARS['urlscript'] : $path, 
			'EMAILADMIN' => $HTTP_POST_VARS['emailadmin'] 
		));
	}
	
	if( $error )
	{
		$template->assign_block_vars('form.error', array(
			'MSG_ERROR' => $msg_error 
		));
	}
}

$template->pparse('body');
?>